﻿using System;
using System.IO;
using System.Reflection;

namespace Was.OrcSearch.Helpers
{
    public static class PathHelper
    {
        public static string GetRootDirectory()
        {
            var codeBase = Assembly.GetExecutingAssembly().CodeBase;
            var uri = new UriBuilder(codeBase);
            var path = Uri.UnescapeDataString(uri.Path);

            var directory = Path.GetDirectoryName(path);

            directory = Path.Combine(directory, "search");

            if (!Directory.Exists(directory)) Directory.CreateDirectory(directory);

            return directory;
        }
    }
}