﻿using Was.OrcSearch.Models.Interfaces;

namespace Was.OrcSearch.Metadata.Interfaces
{
    public interface ISearchableMetadata : IMetadata
    {
        string SearchName { get; set; }

        /// <summary>
        ///     Gets or sets a value indicating whether this property must be analyzed. Set this value to <c>true</c> for common
        ///     text
        ///     or <c>false</c> for unique keys such as product ids.
        ///     <para />
        ///     The default value is <c>true</c>.
        /// </summary>
        /// <value><c>true</c> if analyze; otherwise, <c>false</c>.</value>
        bool Analyze { get; set; }
    }
}